// ****************************************************************************
// copyright (c) 2000-2004 Horst Knorr <hk_classes@knoda.org>  
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file LGPL included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_KDEDBDESIGNER
#define HK_KDEDBDESIGNER
#include <qwidget.h>
#include <qlabel.h>
#include <qlistbox.h>
#include <qframe.h>
#include <hk_dbvisible.h>
#include <hk_dsdatavisible.h>



class hk_presentation;
class hk_kdedbdesignerprivate;
class hk_kdedatasourceframe;
class QVBoxLayout;


class hk_kdedbdesigner:public QWidget, public hk_dbvisible
{
    Q_OBJECT
public:
hk_kdedbdesigner( );
virtual ~hk_kdedbdesigner();
void set_presentation(hk_presentation*);
hk_presentation* presentation(void);

public slots:
void clear_datasources();
void set_datasources();

private:
hk_kdedatasourceframe* get_frame(hk_datasource*);
hk_kdedbdesignerprivate* p_private;
};







class kdedatasourcelabel:public QLabel
{
public:
friend class hk_kdedatasourceframe;
kdedatasourcelabel(QWidget* w);
protected:
bool  eventFilter(QObject* /*object*/, QEvent* event);
void mousePressEvent(QMouseEvent* event);
void mouseReleaseEvent(QMouseEvent* event);
bool p_drag;
int p_startx;
int p_starty;
int p_offsetx;
int p_offsety;
};



class hk_kdefieldlist:public QListBox
{
public:
hk_kdefieldlist(QWidget* parent);
void setFocus(void);
void clearFocus(void);
};






class hk_kdedatasourceframe :public QFrame, public hk_dsdatavisible
{
Q_OBJECT
public:
friend class hk_kdedbdesigner;
hk_kdedatasourceframe(hk_kdedbdesigner* designer,QWidget* parent,hk_datasource* ds);
void set_fields(void);
void setFocus(void);
void clearFocus(void);
void mousePressEvent(QMouseEvent*);

signals:
void signal_moved(void);

protected:
virtual void moveEvent(QMoveEvent*);

private:

hk_kdedbdesigner* p_designer;
QListBox* 	p_listbox;
QVBoxLayout*	p_layout;
kdedatasourcelabel* p_header;
bool p_positionupdate;

};  //end hk_kdedatasourceframe


class hk_kdedbrelation:public QWidget,public hk_class
{
Q_OBJECT
public:
hk_kdedbrelation(QWidget* parent);
~hk_kdedbrelation();
void setAutoMask(bool);
void set_datasources(hk_kdedatasourceframe* master,hk_kdedatasourceframe* slave);
hk_kdedatasourceframe* masterdatasource(void) const;
hk_kdedatasourceframe* slavedatasource(void) const;

protected:
void paint_relation(QPainter*);
void paintEvent(QPaintEvent*);
void updateMask(void);


protected slots:

void datasource_moved(void);

private:
hk_kdedatasourceframe* p_masterdatasource;
hk_kdedatasourceframe* p_slavedatasource;
int p_fromx,p_fromy,p_tox,p_toy;
};






#endif //HK_KDEDBDESIGNER
